#include <stdio.h>
#include <sys/time.h>

/*
#define TESTING
*/

#ifdef TESTING
static int numoftrials = 1; /*300*/;
#else
static int numoftrials = 200; /*300*/;
#endif

#define PRECISION 256
#define PRECISION_DIV_4 64
#define PRECISION_IN_BITS 8
#define COARSENESS 0x8000
#define COARSENESS_SHIFTED 0x80000000
typedef struct {
  int lower;
  int upper;
} tempevent_type;

typedef struct {
  int left[PRECISION+2];
  int right[PRECISION+2];
} tempdist_type;

typedef enum {FALSE, TRUE} bool;

tempdist_type uniform;

int pregammas[101];

void main() {
  int i, j, k;
  int times[101];
  int temps[101];
  void printf(), gettimeofday();
  bool before();
  struct timeval tp1, tp2;
  int temp1, temp2;
  int gamma, temp;
  tempevent_type alpha, beta;

  temp = 0;
  alpha.lower = 1;
  alpha.upper = 256;
  beta.lower = 1;
  beta.upper = 256;
  for (i=1;i<PRECISION+1;i++) {
    uniform.left[i] = ((COARSENESS/PRECISION) * i);
    /*
    uniform.right[i-1] = ((COARSENESS/PRECISION) * i);
    */
    uniform.right[i] = ((COARSENESS/PRECISION) * i);
    }
  uniform.left[0] = 0;
  uniform.right[0] = 0;
  uniform.left[PRECISION+1] = 2*COARSENESS;
  uniform.right[PRECISION+1] = 2*COARSENESS;
  /*
  uniform.right[PRECISION] = PRECISION;
  */

#define GAMMA_MULT PRECISION * PRECISION / 100;
  for (i=0;i<101;i++) pregammas[i] = i * GAMMA_MULT;

  for (i=1+numoftrials;i<=100+numoftrials;i++) {

    gettimeofday(&tp1,NULL);

    for (j=0; j<numoftrials; j++) temp += before(i - numoftrials,&alpha,&beta);

    gettimeofday(&tp2,NULL);

    temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
    temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
    temp1 = temp2 - temp1;

    /*
    if (k) printf("TRUE %d %d ", k, i);
    else printf("False %d %d ", k, i);
    printf("%d\n", (temp1/numoftrials));
    */
    times[i-numoftrials] = temp1;
    temps[i-numoftrials] = temp;
    }
    for (i = 1; i <= 100; i++) printf("%d %d %d\n", temps[i], i, times[i]/numoftrials);
}

bool before(int gamma, tempevent_type *alpha, tempevent_type *beta) 
{
  int  target, mal_target;
  unsigned long arange, brange, agranulesize, bgranulesize, acurrent, bcurrent,
	atest, btest, ahowmanyrods, bhowmanyrods, adistcurrent, bdistcurrent;
  register int exceeded;
  void printf(), exit();
  register int *temp;
  unsigned long long denominator;

  /* Determinate precedes? */
  if (beta->upper < alpha->lower) return FALSE;
  if (alpha->upper < beta->lower) return TRUE;

  /* Assert --> The periods of indeterminacy must overlap */

  /* Need a determinate before?*/ /* Is this true? */
  if (gamma == 100) return FALSE;

  /* Is the indeterminacy trivial? */ /* Is this true? */
  if (gamma == 1) return TRUE;

  target = pregammas[gamma];
  mal_target = pregammas[100 - gamma];

  /* determine ranges */
  arange = (alpha->upper - alpha->lower) + 1;
  brange = (beta->upper - beta->lower) + 1;

  if ((arange <= COARSENESS) && (brange <= COARSENESS)) {
    denominator = arange;
    agranulesize = COARSENESS_SHIFTED/denominator;
    denominator = brange;
    bgranulesize = COARSENESS_SHIFTED/denominator; 
    }

    if (alpha->lower < beta->lower) {
      acurrent = (beta->lower - alpha->lower) * agranulesize;
      atest = acurrent >> 16;
      exceeded = 0;
      for (temp = &uniform.left[0]; *temp++ < atest; exceeded++);
      target -= exceeded << PRECISION_IN_BITS;
      if (target <= 0) return TRUE;
      bcurrent = 0;
      adistcurrent = exceeded;
      bdistcurrent = 0;
      }
    else {
      bcurrent = (alpha->lower - beta->lower) * agranulesize;
      btest = bcurrent >> 16;
      exceeded = 0;
      for (temp = &uniform.right[0]; *temp++ < btest; exceeded++);
      mal_target -= exceeded << PRECISION_IN_BITS;
      if (mal_target <= 0) return FALSE;
      bdistcurrent = exceeded;
      adistcurrent = 0;
      acurrent = 0;
      }

  if ((arange <= PRECISION_DIV_4) && (brange <= PRECISION_DIV_4)) {

    /* Increment on Granules if there are few in each range */
    do {

      /* Get next granule in alpha */
      acurrent += agranulesize;
      atest = acurrent >> 16;
      exceeded = adistcurrent;
      for (temp = &uniform.left[adistcurrent]; *temp++ < atest; exceeded++);
      ahowmanyrods = exceeded - adistcurrent;
      adistcurrent = exceeded;

      /* Get next granule in beta */
      bcurrent += bgranulesize;
      btest = bcurrent >> 16;
      exceeded = bdistcurrent;
      for (temp = &uniform.right[bdistcurrent]; *temp++ < btest; exceeded++);
      bhowmanyrods = exceeded - bdistcurrent;
      bdistcurrent = exceeded;

      target -= ahowmanyrods * (PRECISION - bdistcurrent);
      mal_target -= bhowmanyrods * (PRECISION - adistcurrent);
      
      if (target <= 0) return TRUE;
      if (mal_target <= 0) return FALSE;
      } while ((bdistcurrent < PRECISION) && (adistcurrent < PRECISION));
  }

  else {

    /* Increment on rods because they are fewer than granules */
    unsigned int ahowmanygranules, bhowmanygranules, 
		 anext, bnext, getalpha, getbeta;

    arodsskipped = 0;
    brodsskipped = 0;

    do {

      if (acurrentgranule <= bcurrentgranule) {
        /* Get next rod in alpha */
	atarget = uniform.left[++adistcurrent]
        anext = atarget * agranulesize;
	atemp = anext >> 16 + alpha.lower;
	if (atemp <= acurrentgranule) {
	  arodsskipped++;
	  }
        else {
	  acurrentgranule = atemp;
	  }
	}

      if (bcurrentgranule <= acurrentgranule) {
        /* Get next rod in beta */
	btarget = uniform.left[++bdistcurrent]
        bnext = btarget * bgranulesize;
	btemp = bnext >> 16 + beta.lower;
	if (btemp <= bcurrentgranule) {
	  brodsskipped++;
	  }
        else {
	  bcurrentgranule = btemp;
	  }
	}

      if (target <= 0) return TRUE;
      if (mal_target <= 0) return FALSE;
      } while ((bdistcurrent < PRECISION) && (adistcurrent < PRECISION));
    }

  return FALSE;
}
