#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt_internal/intind.h"
#include "tadt/ext.h"

typedef struct {
  int value;
  int *right;
  int *left;
} tree_space_type;

/*
#define BIN_SEARCH_TESTING
#define TESTING
*/

/* extern unsigned short c_to_p[0x10000]; */
typedef tree_space_type *tree_type;

static node_space_type nodes[DIST_MAX*2];
static int free_nodes, occupied_nodes;
static tree_space_type alpha_tree[DIST_MAX*2];
static tree_space_type beta_tree[DIST_MAX*2];

bool before(int gamma, ind_type ev1, ind_type ev2) 
{
  static void dump_ind_event(ind_type);
  unsigned short mid;
  int  target, mal_target,
       i, left, right, probe, test, range;
  node_type t, dest;
  event_aux_space_type alpha, beta;
  int aleft, aright, amid;
  int bleft, bright, bmid;
  int amidfloor, amidceil, bmidfloor, bmidceil;
  int reversed, shift, temp;
  int adjustment;
  unsigned long rangeconstant;
  unsigned long arange, brange, maxrange;
  unsigned long long arangell, brangell, maxrangell;
  long long min;
  void printf(), exit();

  /* Determinate precedes? */
  if (ev2->finish <= ev1->start) return FALSE;
  if (ev1->finish < ev2->start) return TRUE;

  /* Assert --> The periods of indeterminacy must overlap */

  /* Need a determinate before?*/ /* Is this true? */
  if (gamma == 100) return FALSE;

  /* Is the indeterminacy trivial? */ /* Is this true? */
  if (gamma == 1) return TRUE;

  target = gamma * GAMMA_MULT; 
  mal_target = (100 - gamma) * GAMMA_MULT; 

  arange = (ev1->finish - ev1->start) + 1;
  brange = (ev2->finish - ev2->start) + 1;

  free_nodes = 1;
  occupied_nodes = 0;
  t = &nodes[occupied_nodes]; 
  t->alpha.from = DIST_MIN;
  t->alpha.to = DIST_MAX;
  t->alpha.prob = DIST_MAX;
  t->beta.from = DIST_MIN;
  t->beta.to = DIST_MAX;
  t->beta.prob = DIST_MAX;
  alpha_tree = NULL;
  beta_tree = NULL;

  do {

    /* Error Testing */
    if (occupied_nodes > DIST_MAX) {
       for(i=0;i<occupied_nodes;i++) {
	 printf("a %d af %d at %d b %d bf %d bt %d\n", 
	  nodes[i].alpha.prob,
	  nodes[i].alpha.from_prob,
	  nodes[i].alpha.to_prob,
	  nodes[i].beta.prob,
	  nodes[i].beta.from_prob,
	  nodes[i].beta.to_prob);
	  }
       printf("%d \n", occupied_nodes);
       exit(1);
       }

    /* Get a node */
    t = &nodes[occupied_nodes]; 
    occupied_nodes++;

    /* Binary search to find the probability in beta just below the probe */
    aleft = t->alpha.from;
    aright = t->alpha.to;
    arange = (aleft - aright) + 1;

    amid = arange/2;
    alpha.prob_left = amid;
    alpha.prob_right = arange - amid;
    amidfloor = ev1->dist->floor[aleft + amid];
    amidceil = ev1->dist->floor[aleft + amid];

    left = t->beta.from_prob;
    right = t->beta.to_prob;
    temp = right-left;
    probe = bmidceil;
    for (range = temp; range > 1; range = right-left) {

      mid  = (range >> 1) + left;
      test = ev2->dist->ceiling[mid];
      if (test > probe) {
        right = mid;
        }
      else {
        left = mid;
        }

#ifdef BIN_SEARCH_TESTING
printf("test %d probe %d range %d mid %d left %d right %d\n", 
test, probe, range, mid, left, right);
#endif

      }

    /* Choose a pivot by halving alpha's (assuming alpha has the smaller
       superchronon range) probability */

    /* Translate left side of alpha superchronon to beta superchronon */
    amidfloor = ev1->dist->floor[t->alpha.from_prob + alpha.mid_prob];
    bmidfloor = (amidfloor * rangeconstant) + adjustment;

    /* Translate right side of alpha superchronon to beta superchronon */
    amidceil = ev1->dist->floor[t->alpha.from_prob + alpha.mid_prob];
    bmidceil = (amidceil * rangeconstant) + adjustment;

    /* Add stuff here - Special Cases */
    /*
    if (bmidceil > MAX_SC) bmid = MAX_SC;
    if (bmidfloor < MIN_SC) bmid = MIN_SC;
    */

#ifdef TESTING
printf("amid %d rangeconstant %d adjustment %d bmid %d\n", amid, rangeconstant, adjustment, bmid);
#endif

    /* Binary search to find the probability in beta just below the probe */
    left = t->beta.from_prob;
    right = t->beta.to_prob;
    temp = right-left;
    probe = bmidceil;
    for (range = temp; range > 1; range = right-left) {

      mid  = (range >> 1) + left;
      test = ev2->dist->ceiling[mid];
      if (test > probe) {
        right = mid;
        }
      else {
        left = mid;
        }

#ifdef BIN_SEARCH_TESTING
printf("test %d probe %d range %d mid %d left %d right %d\n", 
test, probe, range, mid, left, right);
#endif

      }

    beta.prob_right = t->beta.to_prob - right;

    /* Figure out other intersect */
    /* Binary search to find the probability in beta just above the probe */
    left = t->beta.from_prob;
    right = t->beta.to_prob;
    temp = right-left;
    probe = bmidfloor;
    for (range = temp; range > 1; range = right-left) {

      mid  = (range >> 1) + left;
      test = ev2->dist->floor[mid];
      if (test > probe) {
        right = mid;
        }
      else {
        left = mid;
        }

#ifdef BIN_SEARCH_TESTING
printf("test %d probe %d range %d mid %d left %d right %d\n", 
test, probe, range, mid, left, right);
#endif

      }

    beta.prob_left = left - t->beta.from_prob;

    /*
    beta.mid_prob = c_to_p[bmid] - t->beta.from_prob;

    temp = (t->beta.to_prob - t->beta.from_prob) + 1;
    beta.prob_left = beta.mid_prob;
    beta.prob_right= temp - beta.mid_prob;
    */


printf("bf %d bt %d br %d bl %d bm %d\n", 
       t->beta.from_prob, t->beta.to_prob, 
       beta.prob_right, beta.prob_left, beta.mid_prob);

printf("af %d at %d ar %d al %d am %d\n", 
       t->alpha.from_prob, t->alpha.to_prob,  
       alpha.prob_right, alpha.prob_left, alpha.mid_prob);

#ifdef TESTING
printf("bmid %d target %d mal_target %d\n", bmid, target, mal_target);
#endif

    mal_target -= alpha.prob_right * beta.prob_left; 
    target -= alpha.prob_left * beta.prob_right; 

/*
printf("%d %d %d\n", bmid, target, mal_target);
*/

    /* Satisfied? */
    if (target < 0) return !reversed;

    /* Opposite proved? */
    if (mal_target < 0) return reversed;

    /*
    beta.prob_left = t->beta.prob - beta.prob_right;
    */
    if ((beta.prob_left > 1) && (alpha.prob_left > 1)) {
      dest = &nodes[free_nodes];
      dest->alpha.from_prob = t->alpha.from_prob;
      dest->alpha.to_prob = t->alpha.from_prob + alpha.mid_prob - 1;
      dest->alpha.prob = alpha.prob_left;
      /* dest->beta.to_prob = t->beta.from_prob + beta.mid_prob - 1; */
      dest->beta.from_prob = t->beta.from_prob;
      dest->beta.to_prob = t->beta.to_prob - beta.prob_right; 
      /* dest->beta.to_prob = t->beta.from_prob + beta.prob_left; */
      dest->beta.prob = beta.prob_left;
      free_nodes++;
      }

    if ((beta.prob_right > 1) && (alpha.prob_right > 1)) {
      dest = &nodes[free_nodes];
      dest->alpha.from_prob = t->alpha.from_prob + alpha.mid_prob;
      dest->alpha.to_prob = t->alpha.to_prob;
      dest->alpha.prob = alpha.prob_right;
      /* dest->beta.from_prob = t->beta.from_prob + beta.mid_prob; */
      dest->beta.from_prob = t->beta.from_prob + beta.prob_left;
      /*dest->beta.from_prob = t->beta.to_prob - beta.prob_right; */
      dest->beta.to_prob = t->beta.to_prob;
      dest->beta.prob = beta.prob_right;
      free_nodes++;
      }

    } while (occupied_nodes != free_nodes);
  return FALSE;
}
