#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt_intind.h"
#include "tadt_ext.h"
#include "tadt_builtin.h"
#include "tadt_comparison.h"
#include "tadt_arithmetic.h"

#define  ADD  1
#define  SUB  2 
#define  MUL  3 
#define  DIV  4

#define  BYTE_MULT(xz,yz,carryz,tempz,zz) \
    if (xz < yz) \
    tempz = mult_char_by_char[xz][yz] + carryz; \
    else tempz = mult_char_by_char[yz][xz] + carryz; \
    carryz = tempz >> 8; \
    zz = tempz

#define  MULT_CHAR_BY_LONG_LONG(x,y,z)  { \
    unsigned short temp; \
    unsigned char carry = 0; \
    unsigned char *py,*pz; \
    py = (unsigned char *)&y; \
    pz = (unsigned char *)&z; \
    BYTE_MULT(x,py[7],carry,temp,pz[7]); \
    BYTE_MULT(x,py[6],carry,temp,pz[6]); \
    BYTE_MULT(x,py[5],carry,temp,pz[5]); \
    BYTE_MULT(x,py[4],carry,temp,pz[4]); \
    BYTE_MULT(x,py[3],carry,temp,pz[3]); \
    BYTE_MULT(x,py[2],carry,temp,pz[2]); \
    BYTE_MULT(x,py[1],carry,temp,pz[1]); \
    BYTE_MULT(x,py[0],carry,temp,pz[0]); \
    }


static unsigned short div_256_by_char[256];
static unsigned short mult_char_by_char[257][257];

/*
* Routine: main
*
* Description: 
*
* Arguments: 
*
* Return Value: None
*
* Errors: None
*
* Side Effects: None
*/
void main() {

  int i, j;
  ind_space_type ev1, ev2;
  bool shrink_l(bool, int, ind_type, ind_type);
  void printf();
  struct timeval tp1, tp2;
  int temp1, temp2, numoftrials;
  dist_space_type uniform;
  bool eval;

  for (i=0;i<257;i++) {
    for (j=0;j<257;j++) {
      mult_char_by_char[i][j] = i * j;
      }
    }


  for (i=1;i<100;i++) {
    uniform.LO_to_sc[i] = (i*256)/100;
    }
  uniform.LO_to_sc[1] = 1;
  uniform.LO_to_sc[0] = 1;

  for (i=1;i<100;i++) {
    uniform.RO_to_sc[i] = ((100-i)*256)/100;
    }

  uniform.RO_to_sc[100] = 1;
  uniform.RO_to_sc[101] = 1;
  uniform.RO_to_sc[1] = 256;
  uniform.RO_to_sc[0] = 256;

  for (i=1;i<258;i++) {
    uniform.sc_to_SP[i] = (100*i)/256;
    }
  for (i=1;i<257;i++) {
    uniform.sc_to_TP[i+1] = 100 - ((100*i)/256);
    }

  uniform.sc_to_TP[1] = 100;

  for (i = 1; i < 256; i++) div_256_by_char[i] = 256/i;
  div_256_by_char[0] = 0;

  /* event_type(1, 200000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev1.start = 1;
  ev1.finish = 200000;
  ev1.left_offset = 0;
  ev1.right_offset = 0;
  ev1.dist = &uniform;
  ev1.determinate = FALSE;

  /* event_type(100001, 300000, 0, 0, 0, 0, 0, 0, 0, uniform, 0) */
  ev2.start = 100001;
  ev2.finish = 300000;
  ev2.left_offset = 0;
  ev2.right_offset = 0;
  ev2.dist = &uniform;
  ev2.determinate = FALSE;

  numoftrials = 3000;
  for (i=1;i<101;i++) {

    gettimeofday(&tp1,NULL);

    for (j=0; j<numoftrials; j++) eval = shrink_l(TRUE, i, &ev1, &ev2);

    gettimeofday(&tp2,NULL);

    printf("%d\n", i);
    temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
    temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
    temp1 = temp2 - temp1;
    printf("%d\n", temp1/numoftrials);
    printf("%d\n", 0);
    if (eval) printf("TRUE %d %d\n", i);
    else printf("False %d %d\n", i);

    }

  /*
  if (adjust(75,ev1,ev2)) printf("OK");
  else printf("Bad");
  print_stats();
  */
  }

bool shrink_l(bool working, int gamma, ind_type ev, ind_type result)
{
  short       lo;
  short       ro;
  short sc_offset, sc_range, new_sc;
  unsigned long long chr_range;
  unsigned long long longlongguy;
  short       from_sc, to_sc, o_sc, new_gamma;

  /* Bail out of expression evaluation? */
  if (!working) return FALSE;
  
  *result = *ev;
  /* Determinate event? */
  if (ev->determinate) return TRUE;

  /* Should we shrink? */
  if (gamma == 0) return TRUE;

  /* Shrink to maximum? */
  if (gamma == 100) {
    result->finish = result->start;
    result->determinate = TRUE;
    result->range = 0;
    return TRUE;
    }

  /* Uniform Distribution? */
  /*
  if (ev->dist == UNIFORM_DIST) {
    return TRUE;
    }
  */

  /* Non Uniform Distribution */

  /* Scale the confidence */
  /*   ngamma = gamma * [(100 - (LO + RO))/100] + LO */
  lo = ev->left_offset;
  ro = ev->right_offset;
  new_gamma = mult_char_by_char[gamma][100 - (lo + ro)]/100 + lo;
  
  /* Figure out which superchronon is confidence */
  /* offset sc */
  o_sc = ev->dist->LO_to_sc[new_gamma];

  /* from sc */
  from_sc = ev->dist->LO_to_sc[lo];

  /* to sc */
  to_sc = ev->dist->RO_to_sc[ro];

/*TEST
printf("to %d from %d offset %d \n", to_sc, from_sc, o_sc);
*/

  /*
  map_sc_to_chr(o_sc,from_sc,to_sc,&ev->start,&ev->finish,&ev->start);
  */

  sc_offset = o_sc - from_sc;
  sc_range = to_sc - from_sc;

  chr_range = (ev->finish - ev->start) >> 8; 
  /* Floating point? */
  if (new_sc < gamma) new_sc = mult_char_by_char[div_256_by_char[sc_range]][sc_offset]; 
  else new_sc = mult_char_by_char[div_256_by_char[sc_range]][sc_offset]; 

  /*
  result->start = ((new_sc * chr_range) >> 8) + ev->start;
  */
  MULT_CHAR_BY_LONG_LONG(new_sc,chr_range,longlongguy);
  result->start = longlongguy + ev->start;
  
/*
  printf("New Chronon is %d %d\n", result->start);
*/
  
  result->left_offset = new_gamma + lo;
  return TRUE;
  }

/*ICON
procedure shrink_r( gamma, copyevnt )
  local tmp, c, ngamma, osc, fsc, tsc, sc, chr, lo, ro

  evnt := copyevent(copyevnt)

  #------------- Map of GAMMA
  # is  newgamma = gamma * [(100 - (LO + RO))/100] + LO

  # Table lookup
  # c := (100 - (LO + RO)) / 100
  tmp := add(evnt.dist.lo,evnt.dist.ro)
  tmp := sub(100.0,tmp)
  c   := div(tmp,100.0)  # table lookup

  # ngamma = (100 - RO) - gamma * c 
  tmp := mul(gamma,c)
  ngamma := sub(100,evnt.dist.ro)
  ngamma := sub(ngamma,tmp)

  #------------- End Map of GAMMA 

  # ------------ Figure out which superchronon is confidence
  osc := evnt.dist.norm.SP[integer(ngamma)]  #offset sc
  lo := add(evnt.dist.lo,1)
  fsc := evnt.dist.norm.SP[lo]              #from sc
  ro := sub(100,evnt.dist.ro)
  tsc := evnt.dist.norm.SP[ro]              #to sc
  # ------------ 

  chr := map_sc_to_chr(osc,fsc,tsc,evnt.start,evnt.finish)
  
  write("New Chronon is " || integer(chr))
  
  evnt.dist.ro := add(evnt.dist.ro,gamma)
  evnt.finish:= integer(chr)
  return evnt
end
ICON*/

/*CODE
bool adjust(bool working, int gamma, ind_type ev1, ind_type ev2)
{
CODE*/
  /* Bail out of this expression */
/*CODE
  if (!working) return FALSE;

CODE*/
  /* Trivial adjustment? */
/*CODE
  if (!tadt_e_precedes_e(ev2.start, ev1.finish)) return TRUE;

CODE*/
  /* Gotta adjust the suckers... */
  /* Do maximum adjustment */
/*CODE
  ev1 = shrink_r(working, gamma, ev1); 
  ev2 = shrink_l(working, gamma, ev2);
  if (!tadt_e_precedes_e(ev2.start, ev1.finish)) return TRUE;
   
CODE*/
  /* No adjustment possible */
/*CODE
  return FALSE; 
}

static void map_sc_to_chr(
  unsigned char sc, 
  unsigned char from_sc, 
  unsigned char to_sc, 
  unsigned long long *from_chr, 
  unsigned long long *to_chr,
  unsigned long long *result);
{
  unsigned char sc_offset, sc_range, new_sc;
  unsigned long long chr_range, chr;

  sc_offset = sc - from_sc;
  sc_range = to_sc - from_sc;
  
  *chr_range = *to_chr - *from_chr; 
  new_sc = div_256_by_char[sc_range] * sc_offset; 
    
  *result = ((new_sc * chr_range) >> 8) + from_chr;
}

static void unpack_event(event_type event, ind_type result)
{
  switch (event->generic.ts_type) {
    case low:
      result->ts_type = event->lowres.ts_type;
      result->start_sign = event->lowres.sign;
      result->finish_sign = event->lowres.sign;
      result->start = event->lowres.secondshi;
      result->start = (result->start << 27) | event->lowres.secondslow;
      result->finish = result->start;
      result->dist = NULL;
      result->left_offset = 0;
      result->right_offset = 100;
      result->range = result->finish - result->start;
      result->determinate = TRUE;
      break;

    case indeterminate:
      result->ts_type = event->lowres_nuni.ts_type;
      result->start_sign = event->lowres_nuni.hisign;
      result->finish_sign = event->lowres_nuni.lowsign;
      result->start = event->lowres_nuni.hisecondshi;
      result->start = (result->start << 27) | event->lowres_nuni.hisecondslow;
      result->finish = event->lowres_nuni.lowsecondshi;
      result->finish = (result->finish << 27) | event->lowres_nuni.lowsecondslow;
      result->dist = event->lowres_nuni.dist;
      result->left_offset = event->lowres_nuni.left_off;
      result->right_offset = event->lowres_nuni.rght_off;
      result->range = result->finish - result->start;
      result->determinate = FALSE;
      break;

    default:
      printf("unsupported indeterminate type\n");
      exit(3);
    }

}

static void pack_event(ind_type ind, event_type result)
{

CODE*/
  /* Make indeterminate event determinate */
/*CODE
  if (ind->determinate) ind->ts_type = low;
  if (ind->start == ind->finish) ind->ts_type = low;

  switch (ind->ts_type) {
    case low:
      result->lowres.ts_type = ind->ts_type;
      result->lowres.sign = ind->start_sign;
      result->lowres.secondshi = ind->start >> 27;
      result->lowres.secondslow = ind->start;
      break;

    case indeterminate:
      result->lowres_nuni.ts_type = ind->ts_type;
      result->lowres_nuni.hisign = ind->start_sign;
      result->lowres_nuni.lowsign = ind->finish_sign;
      result->lowres_nuni.hisecondshi = ind->start >> 27;
      result->lowres_nuni.hisecondslow = ind->start;
      result->lowres_nuni.lowsecondshi = ind->finish >> 27;
      result->lowres_nuni.lowsecondslow = ind->finish;
      result->lowres_nuni.dist = ind->dist;
      result->lowres_nuni.left_off = ind->left_offset;
      result->lowres_nuni.rght_off = ind->right_offset;
      break;

    default:
      printf("unsupported type\n");
      exit(3);
    }
}
CODE*/
