/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/fv/fv_external.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef fv_external
#define fv_external

typedef enum { 
  fv_ok, /*successful completion of the routine*/
  fv_index_too_large, /*no string found, a too large index*/
  fv_index_too_small, /*no string found, a too small index*/
  fv_string_unrecognized, /*no index value found, unrecognized string*/
  fv_string_overflow, /*string too long*/
  fv_table_number_undefined, /*no table has this number*/
  fv_table_name_undefined /*no table has this name*/
} fv_error_type; 
  
fv_error_type fv_index_to_string(int table_number, int index, string_struct result);

fv_error_type fv_string_to_index(int table_number, char *string, int *result, int *num_char);

fv_error_type fv_table_name_to_number(char *table_name, int *table_number);

#define fv_max_field_tables 103 
#define fv_max_field_functions 29

typedef struct {
    int min_index;
    int max_index;
    char *(*field_values)[];
} field_value_table;

extern field_value_table field_value_tables[];

typedef struct {
				/* int should be changed to unsigned long */
				/*            \				  */
    fv_error_type (*fv_table_index_to_string)(int, string_struct);
    fv_error_type (*fv_table_string_to_index)(char *, int *, int *);
				/*                     /		  */
				/* same here, change to unsigned long     */
} field_value_function;

extern field_value_function field_value_functions[];

extern char *table_names[];


#endif
