#define ADD_GRANULES(RC,X,Y,Z) \
    switch(X->upack.size) { \
      case 32: RC = int32_add(X->upack32.granules,Y->upack32.granules,Z->upack32.granules); break;\
      case 64: RC = int64_add(X->upack64.granules,Y->upack64.granules,Z->upack64.granules); break;\
      case 96: RC = int96_add(X->upack96.granules,Y->upack96.granules,Z->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro ADD_GRANULES");\
    }

#define SUB_GRANULES(RC,X,Y,Z) \
    switch(X->upack.size) { \
      case 32: RC = int32_sub(X->upack32.granules,Y->upack32.granules,Z->upack.granules); break;\
      case 64: RC = int64_sub(X->upack64.granules,Y->upack64.granules,Z->upack64.granules); break;\
      case 96: RC = int96_sub(X->upack96.granules,Y->upack96.granules,Z->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro SUB_GRANULES");\
    }

#define MULTIPLY_GRANULES(RC,X,Y,Z) \
    switch(X->upack.size) { \
      case 32: RC = int32_mul(X->upack32.granules,Y->upack32.granules,Z->upack.granules); break;\
      case 64: RC = int64_mul(X->upack64.granules,Y->upack64.granules,Z->upack64.granules); break;\
      case 96: RC = int96_mul(X->upack96.granules,Y->upack96.granules,Z->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro MULTIPLY_GRANULES");\
    }

#define LT_GRANULES(RC,X,Y) \
    switch(X->upack.size) { \
      case 32: RC = int32_lt(X->upack32.granules,Y->upack32.granules); break;\
      case 64: RC = int64_lt(X->upack64.granules,Y->upack64.granules); break;\
      case 96: RC = int96_lt(X->upack96.granules,Y->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro LT_GRANULES");\
    }

#define GT_GRANULES(RC,X,Y) \
    switch(X->upack.size) { \
      case 32: RC = int32_gt(X->upack32.granules,Y->upack32.granules); break;\
      case 64: RC = int64_gt(X->upack64.granules,Y->upack64.granules); break;\
      case 96: RC = int96_gt(X->upack96.granules,Y->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro GT_GRANULES");\
    }

#define EQ_GRANULES(RC,X,Y) \
    switch(X->upack.size) { \
      case 32: RC = int32_eq(X->upack32.granules,Y->upack32.granules); break;\
      case 64: RC = int64_eq(X->upack64.granules,Y->upack64.granules); break;\
      case 96: RC = int96_eq(X->upack96.granules,Y->upack96.granules); break;\
      default: internal_error("%s","bad size in the macro EQ_GRANULES");\
    }

