/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/internal.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_internal
#define ucs_internal
#include "cs.h"

#define call_calendar2(f,a)     (*(cal_table[(f)][ucs_cal_number].F1))((a))
#define call_calendar3(f,a,b)   (*(cal_table[(f)][ucs_cal_number].F2))((a),(b))
#define call_calendar4(f,a,b,c) (*(cal_table[(f)][ucs_cal_number].F3))((a),(b),(c))
#define call_calendar4i(f,a,b,c) (*(cal_table[(f)][ucs_cal_number].F3viv))((a),(b),(c))
#define call_calendar4d(f,a,b,c) (*(cal_table[(f)][ucs_cal_number].F3vdv))((a),(b),(c))

typedef enum { ucs_space_token,ucs_field_token,ucs_error_token} ucs_token_type;
#define PROP_START '<'
#define PROP_END   '>'
#define PROP_SEP   ','
#define ESCAPE     '\\'
#define Max_Num_Parts  1  /* start at 0 */

ucs_token_type ucs_get_token(int *strpos, int strlen, char *string,string_struct result[2]);
char * ucs_table_mapper(char *string);
ucs_error_type ucs_find_field_name(string_struct string, calendar_type *calendar,int *result);
ucs_error_type ucs_get_calendar(int cal_number, calendar_type **cal);
#endif

