/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/tadt/test/timestamp_test.c
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
/* Test code for the tadt comparison routines */
#include <stdio.h>
#include "system_wide.h"
#include "tadt.h"
#define MAXEV 11

context_space_type context_space;
context_type context = &context_space;

void main()
{
  event_type ev[MAX_RESOLUTIONS_OF_EVENTS][MAXEV];
  int i, j;
  static void init_determinate();
  void printf();
  seconds_space_type seconds;

  context->precision.precision = 5;

  error_handler();
  tadt_init();
  for (i=0; i<MAXEV; i++) for (j=0; j<MAXEV; j++) {
    ev[i][j] = tadt_allocate_e(i);
    }

  /* Events to test (one of each resolution) */
  /*                         e9 */
  /*                      e8    */
  /*                   e7       */
  /*                e6          */
  /*            origin          */
  /*          e4                */
  /*       e3                   */
  /*    e2                      */
  /* e1                         */

  init_determinate(ev[determinate][0], -5);
  init_determinate(ev[determinate][1], -4);
  init_determinate(ev[determinate][2], -3);
  init_determinate(ev[determinate][3], -2);
  init_determinate(ev[determinate][4], -1);
  init_determinate(ev[determinate][5], 0);
  init_determinate(ev[determinate][6], 1);
  init_determinate(ev[determinate][7], 2);
  init_determinate(ev[determinate][8], 3);
  init_determinate(ev[determinate][9], 4);
  init_determinate(ev[determinate][10], 5);

  for (i=0; i<special; i++) for (j=0; j<MAXEV; j++) {
     if (tadt_e_to_seconds(ev[i][j],&seconds)) {
	  printf("DIED: %d %d\n", i, j);
	  dump_event(ev[i][j]," testing ");
	  }
  }

  context->resolution = chunked;
  init_chunked(&ev[chunked][0], 5);
  tadt_unpack_e(&ev[chunked][0], &ev[chunked][0]);
  dump_event(&ev[chunked][0]," ind event ");
}

static void init_determinate(event_type ev, int32 granules)
{
  ev->determinate.ts_type = determinate;
  ev->determinate.sign = (granules < 0)? 1 : 0;
  ev->determinate.data = granules;
}

static void init_chunked(event_type ev, int32 granules)
{
  ev->chunked.ts_type = indeterminate;
  ev->chunked.missing = FALSE;
  ev->chunked.chunksize = 1;
  ev->chunked.chunks = 1;
  ev->chunked.sign = (granules < 0)? 1 : 0;
  ev->chunked.data = granules;
}
